2018-04-19 12:07:10 +03:00
# Copyright 2018 The Prometheus Authors
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# A common Makefile that includes rules to be reused in different prometheus projects.
# !!! Open PRs only against the prometheus/prometheus/Makefile.common repository!
# Example usage :
2018-10-23 12:55:53 +02:00
# Create the main Makefile in the root project directory.
2018-04-19 12:07:10 +03:00
# include Makefile.common
# customTarget:
2018-04-20 18:35:42 +02:00
# @echo ">> Running customTarget"
2018-04-19 12:07:10 +03:00
#
# Ensure GOBIN is not set during build so that promu is installed to the correct path
u n export GOBIN
GO ?= go
GOFMT ?= $( GO) fmt
FIRST_GOPATH := $( firstword $( subst :, ,$( shell $( GO) env GOPATH) ) )
2018-10-23 12:55:53 +02:00
GOOPTS ?=
2018-11-09 11:55:04 +01:00
GO_VERSION ?= $( shell $( GO) version)
GO_VERSION_NUMBER ?= $( word 3, $( GO_VERSION) )
PRE_GO_111 ?= $( shell echo $( GO_VERSION_NUMBER) | grep -E 'go1\.(10|[0-9])\.' )
2018-10-29 11:29:16 +01:00
u n export GOVENDOR
2018-11-09 11:55:04 +01:00
i f e q ( , $( PRE_GO_ 111) )
2018-10-29 11:29:16 +01:00
ifneq ( ,$( wildcard go.mod) )
# Enforce Go modules support just in case the directory is inside GOPATH (and for Travis CI).
GO111MODULE := on
ifneq ( ,$( wildcard vendor) )
# Always use the local vendor/ directory to satisfy the dependencies.
GOOPTS := $( GOOPTS) -mod= vendor
endif
endif
2018-10-29 10:14:22 +01:00
e l s e
2018-10-29 11:29:16 +01:00
ifneq ( ,$( wildcard go.mod) )
ifneq ( ,$( wildcard vendor) )
2018-10-23 12:55:53 +02:00
$( warning This repository requires Go >= 1.11 because of Go modules )
2018-11-09 11:55:04 +01:00
$( warning Some recipes may not work as expected as the current Go runtime is '$ ( GO_VERSION_NUMBER ) ')
2018-10-29 11:29:16 +01:00
endif
else
# This repository isn't using Go modules (yet).
GOVENDOR := $( FIRST_GOPATH) /bin/govendor
endif
2018-10-26 09:49:20 +02:00
unexport GO111MODULE
2018-10-23 12:55:53 +02:00
e n d i f
2018-04-19 12:07:10 +03:00
PROMU := $( FIRST_GOPATH) /bin/promu
2018-10-26 13:49:06 +02:00
STATICCHECK := $( FIRST_GOPATH) /bin/staticcheck
2018-04-19 13:38:01 +03:00
pkgs = ./...
2018-04-19 12:07:10 +03:00
2018-11-10 16:28:59 +01:00
GO_VERSION ?= $( shell $( GO) version)
GO_BUILD_PLATFORM ?= $( subst /,-,$( lastword $( GO_VERSION) ) )
PROMU_VERSION ?= 0.2.0
PROMU_URL := https://github.com/prometheus/promu/releases/download/v$( PROMU_VERSION) /promu-$( PROMU_VERSION) .$( GO_BUILD_PLATFORM) .tar.gz
2018-04-19 12:07:10 +03:00
PREFIX ?= $( shell pwd )
BIN_DIR ?= $( shell pwd )
DOCKER_IMAGE_TAG ?= $( subst /,-,$( shell git rev-parse --abbrev-ref HEAD) )
2018-07-04 11:27:10 +02:00
DOCKER_REPO ?= prom
2018-04-19 12:07:10 +03:00
2018-06-11 17:51:28 +02:00
.PHONY : all
2018-11-09 15:04:13 +01:00
all : precheck style staticcheck unused build test
2018-04-19 12:07:10 +03:00
2018-07-12 16:53:34 -05:00
# This rule is used to forward a target like "build" to "common-build". This
# allows a new "build" target to be defined in a Makefile which includes this
# one and override "common-build" without override warnings.
% : common -% ;
.PHONY : common -style
common-style :
2018-04-19 12:07:10 +03:00
@echo ">> checking code style"
2018-08-07 12:19:19 +02:00
@fmtRes= $$ ( $( GOFMT) -d $$ ( find . -path ./vendor -prune -o -name '*.go' -print) ) ; \
if [ -n " $$ {fmtRes} " ] ; then \
echo "gofmt checking failed!" ; echo " $$ {fmtRes} " ; echo; \
echo " Please ensure you are using $$ ( $( GO) version) for formatting code. " ; \
exit 1; \
fi
2018-04-19 12:07:10 +03:00
2018-07-12 16:53:34 -05:00
.PHONY : common -check_license
common-check_license :
2018-04-19 12:07:10 +03:00
@echo ">> checking license header"
@licRes= $$ ( for file in $$ ( find . -type f -iname '*.go' ! -path './vendor/*' ) ; do \
awk 'NR<=3' $$ file | grep -Eq "(Copyright|generated|GENERATED)" || echo $$ file; \
done ) ; \
if [ -n " $$ {licRes} " ] ; then \
echo "license header checking failed:" ; echo " $$ {licRes} " ; \
exit 1; \
fi
2018-07-12 16:53:34 -05:00
.PHONY : common -test -short
common-test-short :
2018-04-19 12:07:10 +03:00
@echo ">> running short tests"
2018-10-23 12:55:53 +02:00
GO111MODULE = $( GO111MODULE) $( GO) test -short $( GOOPTS) $( pkgs)
2018-04-19 12:07:10 +03:00
2018-07-12 16:53:34 -05:00
.PHONY : common -test
common-test :
2018-04-19 12:07:10 +03:00
@echo ">> running all tests"
2018-10-23 12:55:53 +02:00
GO111MODULE = $( GO111MODULE) $( GO) test -race $( GOOPTS) $( pkgs)
2018-04-19 12:07:10 +03:00
2018-07-12 16:53:34 -05:00
.PHONY : common -format
common-format :
2018-04-19 12:07:10 +03:00
@echo ">> formatting code"
2018-10-23 12:55:53 +02:00
GO111MODULE = $( GO111MODULE) $( GO) fmt $( GOOPTS) $( pkgs)
2018-04-19 12:07:10 +03:00
2018-07-12 16:53:34 -05:00
.PHONY : common -vet
common-vet :
2018-04-19 12:07:10 +03:00
@echo ">> vetting code"
2018-10-23 12:55:53 +02:00
GO111MODULE = $( GO111MODULE) $( GO) vet $( GOOPTS) $( pkgs)
2018-04-19 12:07:10 +03:00
2018-07-12 16:53:34 -05:00
.PHONY : common -staticcheck
common-staticcheck : $( STATICCHECK )
2018-04-19 12:07:10 +03:00
@echo ">> running staticcheck"
2018-10-29 12:22:01 +01:00
i f d e f G O 1 1 1 M O D U L E
GO111MODULE = $( GO111MODULE) $( STATICCHECK) -ignore " $( STATICCHECK_IGNORE) " -checks "SA*" $( pkgs)
2018-10-25 16:40:05 +02:00
e l s e
2018-10-29 12:22:01 +01:00
$( STATICCHECK) -ignore " $( STATICCHECK_IGNORE) " $( pkgs)
2018-10-25 16:40:05 +02:00
e n d i f
2018-04-19 12:07:10 +03:00
2018-07-12 16:53:34 -05:00
.PHONY : common -unused
common-unused : $( GOVENDOR )
2018-10-29 11:29:16 +01:00
i f d e f G O V E N D O R
2018-04-19 12:07:10 +03:00
@echo ">> running check for unused packages"
2018-04-19 15:07:55 +03:00
@$( GOVENDOR) list +unused | grep . && exit 1 || echo 'No unused packages'
2018-10-23 12:55:53 +02:00
e l s e
2018-10-29 11:29:16 +01:00
i f d e f G O 1 1 1 M O D U L E
2018-10-23 12:55:53 +02:00
@echo ">> running check for unused/missing packages in go.mod"
GO111MODULE = $( GO111MODULE) $( GO) mod tidy
2018-10-26 09:55:52 +02:00
@git diff --exit-code -- go.sum go.mod
2018-10-29 10:14:22 +01:00
i f n e q ( , $( wildcard vendor ) )
2018-10-23 12:55:53 +02:00
@echo ">> running check for unused packages in vendor/"
GO111MODULE = $( GO111MODULE) $( GO) mod vendor
2018-10-26 09:55:52 +02:00
@git diff --exit-code -- go.sum go.mod vendor/
2018-10-23 12:55:53 +02:00
e n d i f
2018-10-29 10:14:22 +01:00
e n d i f
2018-10-29 11:29:16 +01:00
e n d i f
2018-04-19 12:07:10 +03:00
2018-07-12 16:53:34 -05:00
.PHONY : common -build
common-build : promu
2018-04-19 12:07:10 +03:00
@echo ">> building binaries"
2018-10-23 12:55:53 +02:00
GO111MODULE = $( GO111MODULE) $( PROMU) build --prefix $( PREFIX)
2018-04-19 12:07:10 +03:00
2018-07-12 16:53:34 -05:00
.PHONY : common -tarball
common-tarball : promu
2018-04-19 12:07:10 +03:00
@echo ">> building release tarball"
$( PROMU) tarball --prefix $( PREFIX) $( BIN_DIR)
2018-07-12 16:53:34 -05:00
.PHONY : common -docker
common-docker :
2018-07-04 11:27:10 +02:00
docker build -t " $( DOCKER_REPO) / $( DOCKER_IMAGE_NAME) : $( DOCKER_IMAGE_TAG) " .
2018-07-12 16:53:34 -05:00
.PHONY : common -docker -publish
common-docker-publish :
2018-07-04 11:27:10 +02:00
docker push " $( DOCKER_REPO) / $( DOCKER_IMAGE_NAME) "
2018-07-12 16:53:34 -05:00
.PHONY : common -docker -tag -latest
common-docker-tag-latest :
2018-07-04 11:27:10 +02:00
docker tag " $( DOCKER_REPO) / $( DOCKER_IMAGE_NAME) : $( DOCKER_IMAGE_TAG) " " $( DOCKER_REPO) / $( DOCKER_IMAGE_NAME) :latest "
2018-04-19 12:07:10 +03:00
2018-06-11 17:51:28 +02:00
.PHONY : promu
2018-11-10 16:28:59 +01:00
promu : $( PROMU )
$(PROMU) :
curl -s -L $( PROMU_URL) | tar -xvz -C /tmp
mkdir -v -p $( FIRST_GOPATH) /bin
cp -v /tmp/promu-$( PROMU_VERSION) .$( GO_BUILD_PLATFORM) /promu $( PROMU)
2018-04-19 12:07:10 +03:00
2018-09-05 20:04:44 +01:00
.PHONY : proto
proto :
@echo ">> generating code from proto files"
@./scripts/genproto.sh
2018-06-11 17:51:28 +02:00
.PHONY : $( STATICCHECK )
$(STATICCHECK) :
2018-10-29 11:29:16 +01:00
i f d e f G O 1 1 1 M O D U L E
# Get staticcheck from a temporary directory to avoid modifying the local go.{mod,sum}.
# See https://github.com/golang/go/issues/27643.
# For now, we are using the next branch of staticcheck because master isn't compatible yet with Go modules.
2018-10-26 13:49:06 +02:00
tmpModule = $$ ( mktemp -d 2>& 1) && \
mkdir -p $$ { tmpModule} /staticcheck && \
cd " $$ {tmpModule} " /staticcheck && \
GO111MODULE = on $( GO) mod init example.com/staticcheck && \
GO111MODULE = on GOOS = GOARCH = $( GO) get -u honnef.co/go/tools/cmd/staticcheck@next && \
rm -rf $$ { tmpModule} ;
e l s e
2018-10-29 11:29:16 +01:00
GOOS = GOARCH = GO111MODULE = off $( GO) get -u honnef.co/go/tools/cmd/staticcheck
e n d i f
2018-04-19 12:07:10 +03:00
2018-10-29 11:29:16 +01:00
i f d e f G O V E N D O R
2018-06-11 17:51:28 +02:00
.PHONY : $( GOVENDOR )
$(GOVENDOR) :
2018-04-19 12:07:10 +03:00
GOOS = GOARCH = $( GO) get -u github.com/kardianos/govendor
2018-10-23 12:55:53 +02:00
e n d i f
2018-11-09 15:04:13 +01:00
.PHONY : precheck
precheck ::
d e f i n e PRECHECK_COMMAND_template =
precheck :: $( 1) _precheck
PRECHECK_COMMAND_$(1) ?= $( 1) $$ ( strip $$ ( PRECHECK_OPTIONS_$( 1) ) )
2018-11-20 17:17:48 +08:00
.PHONY : $( 1) _precheck
2018-11-09 15:04:13 +01:00
$(1)_precheck :
@if ! $$ ( PRECHECK_COMMAND_$( 1) ) 1>/dev/null 2>& 1; then \
echo " Execution of ' $$ (PRECHECK_COMMAND_ $( 1) )' command failed. Is $( 1) installed? " ; \
exit 1; \
fi
e n d e f